#include "ethertap.h"
#include <unistd.h>
#include <stdio.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/time.h>
#include <fcntl.h>
#include <error.h>
#include <errno.h>
#include <sys/errno.h>
#include <netinet/in.h>
#include <string.h>
#include <signal.h>

#define BLOCK_SIZE 4096

ethertap::ethertap(char *t)
 {
  len = 0;
	buf = new char[BLOCK_SIZE + 4];
  fd = ::open(t, O_RDWR);
  if (fd < 0) throw couldNotOpen();
 }

ethertap::~ethertap()
 {
  delete [] buf;
  close(fd);
 }
   
void ethertap::read()
 {
	while( (len = ::read(fd, buf + 4, BLOCK_SIZE)) < 0 )
	{
		// Ignore 'No Buffer Space Available' error
		if( errno != ENOBUFS) throw couldNotRead();
	}
 }

int ethertap::getBufLen()
 {
  return len;
 }
 
char *ethertap::getBuf()
 {
  return buf;
 }
 
void ethertap::write(char *d, int s)
 {
  if (::write(fd, d, s) != s) throw couldNotWrite();
 }
  
ethertap::operator int()
 {
  return fd;
 }
  
