#ifndef network_h
#define network_h

#define BUF_SIZE 4100

extern "C" {
#include <mcrypt-nm.h>
}

class network
{
 public:
   network();
   network(char *host, int p);
   network(int p);
   ~network();
   
   void read(); 
   int getBufLen();
   char *getBuf();
   void write(char *d, int s);
   
   void setLocalSecure(char *s);
   void setRemoteSecure(char *s);
   void setEncryption(int e);
   
   operator int();
   
   void handshake();
   
   class couldNotOpen {};
   class couldNotRead {};
   class couldNotWrite {};
   class authFailure {};
   class unknownEncryption {};   
   class handshakeFailure {};
   class cryptError {};
   class encryptionInconsistent {};
   class userBreak {};
   
 protected:
   char *buf;
   int len;
   int fd;
   
   char *localSecure, *remoteSecure;
   int encryption;
   
   bool handshook;
   void writeInteger(int i);
   int readInteger();
   
   MCRYPT_INT *localCryptor, *remoteCryptor;
   
   char *localIV, *remoteIV;
   void createLocalIV();
   void readRemoteIV();
   void authServer();
   void authClient();
   void electMaster();
   
   bool master;
   bool closeHandle;
 };
 
#endif
